#include "Images.h"

#include "programm.xpm"
#include "uprogramm.xpm"
#include "tree.xpm"

wxBitmap ** bitmaps;

void Image::Init()
{
	bitmaps = new wxBitmap*[BITMAPS];
	bitmaps[0] = new wxBitmap(bmp_home_XPM);
	bitmaps[1] = new wxBitmap(bmp_floppy_XPM);
	bitmaps[2] = new wxBitmap(bmp_closed_folder_XPM);
	bitmaps[3] = new wxBitmap(bmp_open_folder_XPM);
	bitmaps[4] = new wxBitmap(bmp_file_XPM);
	bitmaps[5] = new wxBitmap(bmp_projekt_XPM);
	bitmaps[6] = new wxBitmap(programm_xpm);
	bitmaps[7] = new wxBitmap(uprogramm_xpm);
	bitmaps[8] = new wxBitmap(opened_files_xpm);
}

wxBitmap * Image::Get(int id)
{
	if(id < 0 || id > BITMAPS)
		return &wxNullBitmap;
	else
		return bitmaps[id];
}

/*
00:Tree - Home
01:Tree - Floppy
02:Tree - Open Folder
03:Tree - Closed Folder
04:Tree - File
05:Tree - Project
06:Programm Icon
07:Unterprogramm Icon
08:
09:
10:

*/
