#ifndef PROJECTVIEW_H_INCLUDED
#define PROJECTVIEW_H_INCLUDED

#include <wx/docview.h>
#include "Project.h"

WX_DECLARE_HASH_MAP(int, int, wxIntegerHash, wxIntegerEqual, PrjFileHashMap);

class ProjectView : public wxView
{
public:
	ProjectView();
	bool OnCreate(wxDocument* doc, long flags);
	void OnDraw(wxDC *dc) {}
	void OnChangeFilename();
	void Refresh();
	//Return true wenn es ein Item dieses Projektes ist
	bool DblClick(wxTreeItemId item);
private:
	Project * doc;
	wxTreeItemId m_prjRoot;
	DECLARE_DYNAMIC_CLASS(ProjectView)
	wxTreeCtrl & m_tree;
	PrjFileHashMap m_view_list;
	void AppendTree(wxTreeItemId root, PrjFilesArray & files, int icon);
};

#endif // PROJECTVIEW_H_INCLUDED
