#ifndef TEXTEDITVIEW_H
#define TEXTEDITVIEW_H
#include "wx_pch.h"
#include "TextWindow.h"

class TextEditView: public wxView
{
public:
    MyTextWindow *textsw;
    wxDocument * doc;

    TextEditView(): wxView() { textsw = (MyTextWindow *) NULL; }
    ~TextEditView();

    bool OnCreate(wxDocument *doc, long flags);
    void OnDraw(wxDC *dc);
    void OnUpdate(wxView *sender, wxObject *hint = (wxObject *) NULL);
    bool OnClose(bool deleteWindow = true);
	void OnChangeFilename();
	void RefreshTitle();

private:
	DECLARE_DYNAMIC_CLASS(TextEditView)
};

#endif //TEXTEDITVIEW_H
