#include "App.h"
#include "MyFrame.h"
#include "TextEditView.h"
#include "Programm.h"
#include "UProgramm.h"
#include "Project.h"
#include "ProjectView.h"

IMPLEMENT_APP(MyApp)

MyFrame *frame = (MyFrame *) NULL;

bool MyApp::OnInit()
{
	// Create a document manager
	m_docManager = new MyDocManager;


	(void) new wxDocTemplate(m_docManager, _T("Programm"), _T("*.prog"), _T(""), _T("prog"), _T("Programm"), _T("Text View"),
		  CLASSINFO(Programm), CLASSINFO(TextEditView));
	(void) new wxDocTemplate(m_docManager, _T("Unterprogramm"), _T("*.uprog"), _T(""), _T("uprog"), _T("Unterprogramm"), _T("Text View"),
		  CLASSINFO(UProgramm), CLASSINFO(TextEditView));
	(void) new wxDocTemplate(m_docManager, _T("Projekt"), _T("*.prj"), _T(""), _T("prj"), _T("Projekt"), _T("Projekt View"),
		  CLASSINFO(Project), CLASSINFO(ProjectView));


    frame = new MyFrame(m_docManager,
						NULL,
						wxID_ANY,
						wxT("CNi Floppy"),
						wxDefaultPosition,
						wxSize(800, 600),
						wxDEFAULT_FRAME_STYLE);

    SetTopWindow(frame);
    frame->Show();

    return true;
}

MyFrame *GetMainFrame(void)
{
    return frame;
}


