#ifndef MYDOCMANAGER_H_INCLUDED
#define MYDOCMANAGER_H_INCLUDED

#include <wx/docview.h>
#include "PrjFile.h"

class MyDocManager : public wxDocManager
{
public:
	wxDocument * NewDocument(const wxString & extension, long flags);
	wxDocument * Open(PrjFile * file, int prjId);
    virtual wxDocTemplate *SelectDocumentPath(wxDocTemplate **templates,
            int noTemplates, wxString& path, long flags, bool save = false);

	bool GetShowControlCharacter() { return m_control_character; }
	void SetShowControlCharacter(bool cc);
private:
	bool m_control_character;

};

#endif // MYDOCMANAGER_H_INCLUDED
