#ifndef PRJFILE_H_INCLUDED
#define PRJFILE_H_INCLUDED

class PrjFile {
public:
	PrjFile() { m_data = NULL; }
	~PrjFile() { if(m_data) delete m_data; }
	PrjFile(wxString name, char typ, char * data, int size) {m_name = name; m_typ = typ; m_size = size; m_data = data; }
	wxString GetName() { return m_name; }
	char GetTyp() { return m_typ; }
	int GetSize() { return m_size; }
	char * GetData() { return m_data; }

private:
	wxString m_name;
	char m_typ;
	int m_size;
	char * m_data;
};

//enthlt nur den Namen und die ID
class PrjFiles
{
public:
	PrjFiles() { m_name = "", m_id=-1; }
	PrjFiles(wxString name, int id) { m_name = name, m_id=id; }
	~PrjFiles() { delete m_name; }
	wxString m_name;
	int m_id;
};

#endif // PRJFILE_H_INCLUDED
