#include "UProgramm.h"
#include "TextEditView.h"

using namespace std;

IMPLEMENT_DYNAMIC_CLASS(UProgramm, wxDocument)

UProgramm::UProgramm()
{
	//TODO:Head initialisieren
}

bool UProgramm::OnSaveDocument(const wxString& filename)
{
	GetFirstView()->OnUpdate(NULL);
	FILE * fp;

	fp=fopen(filename.GetData(), "wb");
	if(!fp)
	{
		wxMessageBox("Datei konnte nicht geschrieben werden!", "Fehler", wxOK | wxICON_ERROR);
		return false;
	}

	WriteHead(fp);

	TextEditView *view = (TextEditView *)GetFirstView();

	fprintf(fp, "%s", view->textsw->GetValue().GetData());

	WriteFooter(fp);

	fclose(fp);

    Modify(false);
    return true;
}

bool UProgramm::OpenFile(wxInputStream & in, const wxString & filename)
{
	cout << "UProgramm::OpenFile(" << filename << ")\n";


	int len, i;
	char * bintemp;

	len = in.GetLength();

	bintemp=new char[len+10];
	for(i=0; i < len; i++)
		bintemp[i]=in.GetC();

	ReadHead(53, bintemp);

	SetFileEnde(bintemp, len);

    TextEditView *view = (TextEditView *)GetFirstView();


	wxString tmp(&bintemp[53]);
	view->textsw->SetValue(tmp);

	delete bintemp;

	SetTitle(wxFileNameFromPath(filename));
    SetFilename(filename, false);

	OnFileOpened();
    return true;
}

