#include <stdio.h>
#include <stdlib.h>
#include <string.h>


void getname(char * name, const int addr, const char * path)
{
	
	//in der Datei ..\data\adress.db nach dem Index nachschlagen. Wenn gefunden index.db ffnen, Adresse suche. Name zurckgeben.
	FILE * fpin, *fpout;
	char buffer[512], buffer2[512];
	char filename[512];
	char iadress[128]; //Adresse die im Index steht
	int adress; //effektive Adresse
	fpin=fopen("..\\data\\adress.db", "r");
	if(!fpin)
	{
		printf("%s konnte nicht geoeffnet werden! Error #005\n", "..\\data\\adress.db");
		system("pause");
		exit(5);
	}
	name[0]=0;
	while(fgets(buffer, 512, fpin)!=NULL)
	{
		adress=atoi(strtok(buffer, ";"));
		strncpy(iadress, strtok(NULL, ";"), 128);
		if(addr == adress)
		{
			printf("%i %s\n", adress, iadress);
			fclose(fpin);
			sprintf(filename, "%s\\index.db", path);
			rename(filename, "index.db.2");
			fpin=fopen("index.db.2", "r");
			if(!fpin)
			{
				printf("%s konnte nicht geoeffnet werden! Error #006\n", "index.db.2");
				system("pause");
				exit(6);
			}
			fpout=fopen(filename, "w");
			if(!fpout)
			{
				printf("%s konnte nicht geoeffnet werden! Error #007\n", filename);
				system("pause");
				exit(7);
			}
			while(fgets(buffer, 512, fpin)!=NULL)
			{
				strcpy(buffer2, buffer);
				strtok(buffer2, "\t");
			
				if(strcmp(&iadress[7], strtok(NULL, "\t"))==0)
				{
					strcpy(name, strtok(buffer, "\t "));
					printf("%s gefunden\n", name);
				}
				else
				{
					fprintf(fpout, "%s", buffer);
				}
			}
			fclose(fpin);
			fclose(fpout);
			remove("index.db.2");
			//iadress[9]
			system("pause");
			break;
		}
	}
	fclose(fpin);

	
}


int main(int argc, char** argv)
{
	
	FILE * fp, * fp2, *fp3;
	int i, ch;
	int files=0;
	int lastindex=0;
	char filename[256];
	char path[256];
	char name[16];
	
	//Index lesen und in index.db schreiben
	if(argc==1)
	{
		path[0]='.';
		path[1]=0;		
	}
	else
		strncpy(path, argv[1], 256);

	sprintf(filename, "%s\\img.bin", path);
	fp=fopen(filename, "rb");
	if(!fp)
	{
		printf("%s konnte nicht geoeffnet werden! Error #001\n", filename);
		system("pause");
		exit(1);
	}
	sprintf(filename, "%s\\index.db", path);
	fp2=fopen(filename, "w");
	if(!fp)
	{
		printf("%s konnte nicht geoeffnet werden! Error #002\n", filename);
		system("pause");
		exit(2);
	}
	printf("Index lesen...\n");
	printf("==========================================================\n");
	fseek(fp, 0, SEEK_SET);
	while(!feof(fp) && ftell(fp) < 0xb400)
	{
		ch=getc(fp);
		if(ch == 1 || ch==2)
		{
			if(ch == 1)
			{
				fputc('P', fp2);
				printf("Prog. ", ch);
			}
			else
			{
				fputc('U', fp2);
				printf("Uprg. ", ch);
			}
			for(i=0; i < 11; i++)
			{
				ch=fgetc(fp);
				fputc(ch, fp2);
				printf("%c", ch);
			}
			fputc('\t', fp2);
			printf(" ");
			for(i=0; i < 20; i++)
			{
				ch=fgetc(fp);
				fprintf(fp2, "%02x", ch);
				printf("%02x", ch);
			}
			fputc('\n', fp2);
			printf("\n");
			lastindex=ftell(fp);
		}
		else
		{
			for(i=0; i < 31; i++)
				ch=fgetc(fp);					
		}
	}
	printf("==========================================================\n");
	printf("Lasindex: %i\n", lastindex);

	fclose(fp2);

	sprintf(filename, "%s\\datindex.db", path);
	fp3=fopen(filename, "w");
	if(!fp3)
	{
		printf("%s konnte nicht geoeffnet werden! Error #004\n", filename);
		system("pause");
		exit(4);
	}

	printf("Dateien lesen...\n");
	fseek(fp, lastindex, SEEK_SET);
	i=0;
	while(!feof(fp) && ftell(fp) < 1474048)
	{
		ch=getc(fp);
		//if(ch!=229)	
		//	printf("#%i\n", ftell(fp));	
		if(ch==229 && i==1)
		{
			fclose(fp2);
			i=0;
		}
		else if(ch != 229 && i==1)
		{
			fputc(ch, fp2);
		}
		else if(ch!=229 && i==0)
		{
			files++;
			printf("Datei %i gefunden\n", files);
			getname(name, ftell(fp), path);
			if(name[0]!=0)
			{
				sprintf(filename, "%s\\files\\%s.%c", path, &name[1], name[0]);
			}
			else
			{//Name unbekannt
				sprintf(filename, "%s\\dat%i", path, files);
			}
			printf("%s oeffnen\n", filename);
			fp2=fopen(filename, "w");
			if(!fp2)
			{
				printf("%s konnte nicht geoeffnet werden! Error #003\n", filename);
				system("pause");
				exit(3);
			}
			fprintf(fp3, "%i\tdat%i\n", ftell(fp), files);
			fputc(ch, fp2);
			i=1;
		}
	}
	printf("==========================================================\n");
	fclose(fp);
	fclose(fp3);

    return 0;
}
